blob: 41a0dc2a8465dc790c63e8fb7e5910dc2f4b43fb [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Nicolas Geoffray1c5b6da2016-03-16 10:55:57 +000048export USE_JACK="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070049export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070050
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070051# If dx was not set by the environment variable, assume it is in the path.
52if [ -z "$DX" ]; then
53 export DX="dx"
54fi
55
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080056# If jasmin was not set by the environment variable, assume it is in the path.
57if [ -z "$JASMIN" ]; then
58 export JASMIN="jasmin"
59fi
60
Andreas Gampe8fda9f22014-10-03 16:15:37 -070061# If smali was not set by the environment variable, assume it is in the path.
62if [ -z "$SMALI" ]; then
63 export SMALI="smali"
64fi
65
66# If dexmerger was not set by the environment variable, assume it is in the path.
67if [ -z "$DXMERGER" ]; then
68 export DXMERGER="dexmerger"
69fi
70
Sebastien Hertz19ac0272015-02-24 17:39:50 +010071# If jack was not set by the environment variable, assume it is in the path.
72if [ -z "$JACK" ]; then
73 export JACK="jack"
74fi
75
Sebastien Hertz19ac0272015-02-24 17:39:50 +010076# ANDROID_BUILD_TOP is not set in a build environment.
77if [ -z "$ANDROID_BUILD_TOP" ]; then
78 export ANDROID_BUILD_TOP=$oldwd
79fi
80
Andreas Gampef47fb2f2016-06-24 22:30:29 -070081# ANDROID_HOST_OUT is not set in a build environment.
82if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsenf325e012017-03-03 12:35:30 -080083 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070084fi
85
Sebastien Hertz19ac0272015-02-24 17:39:50 +010086# If JACK_CLASSPATH is not set, assume it only contains core-libart.
87if [ -z "$JACK_CLASSPATH" ]; then
Andreas Gampef47fb2f2016-06-24 22:30:29 -070088 export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010089fi
90
Sebastien Hertz19ac0272015-02-24 17:39:50 +010091export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080092
Igor Murashkin271a0f82017-02-14 21:14:17 +000093# Zipalign is not on the PATH in some configs, auto-detect it.
94if [ -z "$ZIPALIGN" ]; then
95 if which zipalign >/dev/null; then
96 ZIPALIGN="zipalign";
97 else
98 # TODO: Add a dependency for zipalign in Android.run-test.mk
99 # once it doesn't depend on libandroidfw (b/35246701)
100 case "$OSTYPE" in
101 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
102 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
103 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
104 esac
105 fi
106fi
107export ZIPALIGN
108
jeffhao5d1ac922011-09-29 17:41:15 -0700109info="info.txt"
110build="build"
111run="run"
112expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700113check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700114output="output.txt"
115build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100116cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700117strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700118lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700119testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700120run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000121build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700122
Alex Light91de25f2015-10-28 17:00:06 -0700123quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000124debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700125prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700126target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700127dev_mode="no"
128update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700129debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000130relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800131runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700132usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700133build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700134suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700135trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700136trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700137basic_verify="false"
138gc_verify="false"
139gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700140jvmti_trace_stress="false"
141jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700142strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700143always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700144never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700145have_dex2oat="yes"
146have_patchoat="yes"
147have_image="yes"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800148multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000149android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700150bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800151suspend_timeout="500000"
Alex Light10bc5a42016-05-10 10:01:22 -0700152# By default we will use optimizing.
153image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000154image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700155
156while true; do
157 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700158 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700159 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100160 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700161 shift
Alex Light91de25f2015-10-28 17:00:06 -0700162 elif [ "x$1" = "x--quiet" ]; then
163 quiet="yes"
164 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700165 elif [ "x$1" = "x--use-java-home" ]; then
166 if [ -n "${JAVA_HOME}" ]; then
167 export JAVA="${JAVA_HOME}/bin/java"
168 export JAVAC="${JAVA_HOME}/bin/javac -g"
169 else
170 echo "Passed --use-java-home without JAVA_HOME variable set!"
171 usage="yes"
172 fi
173 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800174 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700175 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800176 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800177 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700178 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700179 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700180 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100181 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100182 run_args="${run_args} --jvm"
Alex Lighteb7c1442015-08-31 13:17:42 -0700183 build_args="${build_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700184 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800185 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700186 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700187 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700188 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700189 shift
190 elif [ "x$1" = "x--dalvik" ]; then
191 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800192 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700193 shift
Alex Light03a112d2014-08-25 13:25:56 -0700194 elif [ "x$1" = "x--no-dex2oat" ]; then
195 have_dex2oat="no"
196 shift
197 elif [ "x$1" = "x--no-patchoat" ]; then
198 have_patchoat="no"
199 shift
200 elif [ "x$1" = "x--no-image" ]; then
201 have_image="no"
202 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800203 elif [ "x$1" = "x--multi-image" ]; then
204 multi_image_suffix="-multi"
205 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700206 elif [ "x$1" = "x--pic-test" ]; then
207 run_args="${run_args} --pic-test"
208 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700209 elif [ "x$1" = "x--relocate" ]; then
210 relocate="yes"
211 shift
212 elif [ "x$1" = "x--no-relocate" ]; then
213 relocate="no"
214 shift
215 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100216 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700217 prebuild_mode="yes"
218 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700219 elif [ "x$1" = "x--strip-dex" ]; then
220 run_args="${run_args} --strip-dex"
221 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000222 elif [ "x$1" = "x--debuggable" ]; then
223 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000224 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000225 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700226 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100227 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700228 prebuild_mode="no"
229 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700230 elif [ "x$1" = "x--gcverify" ]; then
231 basic_verify="true"
232 gc_verify="true"
233 shift
234 elif [ "x$1" = "x--gcstress" ]; then
235 basic_verify="true"
236 gc_stress="true"
237 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700238 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
239 jvmti_redefine_stress="true"
240 shift
241 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
242 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700243 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800244 elif [ "x$1" = "x--suspend-timeout" ]; then
245 shift
246 suspend_timeout="$1"
247 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700248 elif [ "x$1" = "x--image" ]; then
249 shift
250 image="$1"
251 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700252 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000253 elif [ "x$1" = "x-Xcompiler-option" ]; then
254 shift
255 option="$1"
256 run_args="${run_args} -Xcompiler-option $option"
257 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000258 elif [ "x$1" = "x--build-option" ]; then
259 shift
260 option="$1"
261 build_args="${build_args} $option"
262 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700263 elif [ "x$1" = "x--runtime-option" ]; then
264 shift
265 option="$1"
266 run_args="${run_args} --runtime-option $option"
267 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700268 elif [ "x$1" = "x--gdb-arg" ]; then
269 shift
270 gdb_arg="$1"
271 run_args="${run_args} --gdb-arg $gdb_arg"
272 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700273 elif [ "x$1" = "x--debug" ]; then
274 run_args="${run_args} --debug"
275 shift
276 elif [ "x$1" = "x--gdb" ]; then
277 run_args="${run_args} --gdb"
278 dev_mode="yes"
279 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700280 elif [ "x$1" = "x--strace" ]; then
281 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700282 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700283 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700284 elif [ "x$1" = "x--zygote" ]; then
285 run_args="${run_args} --zygote"
286 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800287 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000288 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700289 image_suffix="-interpreter"
290 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800291 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700292 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000293 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800294 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700295 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700296 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800297 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700298 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700299 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700300 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700301 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700302 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700303 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700304 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700305 elif [ "x$1" = "x--no-optimize" ]; then
306 run_args="${run_args} --no-optimize"
307 shift
308 elif [ "x$1" = "x--no-precise" ]; then
309 run_args="${run_args} --no-precise"
310 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700311 elif [ "x$1" = "x--invoke-with" ]; then
312 shift
313 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700314 if [ "x$what" = "x" ]; then
315 echo "$0 missing argument to --invoke-with" 1>&2
316 usage="yes"
317 break
318 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700319 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700320 shift
321 elif [ "x$1" = "x--dev" ]; then
322 run_args="${run_args} --dev"
323 dev_mode="yes"
324 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700325 elif [ "x$1" = "x--build-only" ]; then
326 build_only="yes"
327 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100328 elif [ "x$1" = "x--build-with-javac-dx" ]; then
329 USE_JACK="false"
330 shift
331 elif [ "x$1" = "x--build-with-jack" ]; then
332 USE_JACK="true"
333 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700334 elif [ "x$1" = "x--output-path" ]; then
335 shift
336 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700337 if [ "x$tmp_dir" = "x" ]; then
338 echo "$0 missing argument to --output-path" 1>&2
339 usage="yes"
340 break
341 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700342 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000343 elif [ "x$1" = "x--android-root" ]; then
344 shift
345 if [ "x$1" = "x" ]; then
346 echo "$0 missing argument to --android-root" 1>&2
347 usage="yes"
348 break
349 fi
350 android_root="$1"
351 run_args="${run_args} --android-root $1"
352 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700353 elif [ "x$1" = "x--update" ]; then
354 update_mode="yes"
355 shift
356 elif [ "x$1" = "x--help" ]; then
357 usage="yes"
358 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700359 elif [ "x$1" = "x--64" ]; then
360 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700361 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700362 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200363 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700364 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200365 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700366 elif [ "x$1" = "x--stream" ]; then
367 trace_stream="true"
368 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700369 elif [ "x$1" = "x--always-clean" ]; then
370 always_clean="yes"
371 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700372 elif [ "x$1" = "x--never-clean" ]; then
373 never_clean="yes"
374 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800375 elif [ "x$1" = "x--dex2oat-swap" ]; then
376 run_args="${run_args} --dex2oat-swap"
377 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700378 elif [ "x$1" = "x--instruction-set-features" ]; then
379 shift
380 run_args="${run_args} --instruction-set-features $1"
381 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700382 elif [ "x$1" = "x--bisection-search" ]; then
383 bisection_search="yes"
384 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000385 elif [ "x$1" = "x--vdex" ]; then
386 run_args="${run_args} --vdex"
387 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000388 elif [ "x$1" = "x--vdex-filter" ]; then
389 shift
390 filter=$1
391 run_args="${run_args} --vdex-filter $filter"
392 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700393 elif [ "x$1" = "x--random-profile" ]; then
394 run_args="${run_args} --random-profile"
395 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700396 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700397 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700398 usage="yes"
399 break
400 else
401 break
402 fi
403done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700404
Alex Light10bc5a42016-05-10 10:01:22 -0700405run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700406# Allocate file descriptor real_stderr and redirect it to the shell's error
407# output (fd 2).
408if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
409 exec {real_stderr}>&2
410else
411 # In bash before version 4.1 we need to do a manual search for free file
412 # descriptors.
413 FD=3
414 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
415 real_stderr=$FD
416 eval "exec ${real_stderr}>&2"
417fi
418if [ "$quiet" = "yes" ]; then
419 # Force the default standard output and error to go to /dev/null so we will
420 # not print them.
421 exec 1>/dev/null
422 exec 2>/dev/null
423fi
424
425function err_echo() {
426 echo "$@" 1>&${real_stderr}
427}
428
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700429# tmp_dir may be relative, resolve.
430#
431# Cannot use realpath, as it does not exist on Mac.
432# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700433# Cannot use readlink -m, as it does not exist on Mac.
434# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700435noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700436tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700437mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700438
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800439# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000440if [ ! "$runtime" = "jvm" ]; then
441 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
442fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800443
Alex Lighte7873ec2014-08-12 09:53:50 -0700444if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800445 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
446 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700447fi
448if [ "$gc_verify" = "true" ]; then
449 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
450fi
451if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700452 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700453fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700454if [ "$jvmti_redefine_stress" = "true" ]; then
455 run_args="${run_args} --no-app-image --jvmti-redefine-stress"
456fi
457if [ "$jvmti_trace_stress" = "true" ]; then
458 run_args="${run_args} --no-app-image --jvmti-trace-stress"
Alex Light8f2c6d42017-04-10 16:27:35 -0700459fi
Jeff Hao85139a32014-07-23 11:52:52 -0700460if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700461 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
462 if [ "$trace_stream" = "true" ]; then
463 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
464 # the ability to analyze the file and just write to /dev/null.
465 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
466 # Enable streaming mode.
467 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
468 else
469 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
470 fi
471elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700472 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700473 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700474fi
475
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700476# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100477# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100478function guess_target_arch_name() {
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100479 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
Andreas Gampe1a5c4062015-01-15 12:10:47 -0800480 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700481 if [ "x${suffix64}" = "x64" ]; then
482 target_arch_name=${grep64bit}
483 else
484 target_arch_name=${grep32bit}
485 fi
486}
487
David Brazdil853a4c32015-09-28 16:15:50 +0100488function guess_host_arch_name() {
489 if [ "x${suffix64}" = "x64" ]; then
490 host_arch_name="x86_64"
491 else
492 host_arch_name="x86"
493 fi
494}
495
Alex Lighta59dd802014-07-02 16:28:08 -0700496if [ "$target_mode" = "no" ]; then
497 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700498 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700499 err_echo "--prebuild with --jvm is unsupported"
Alex Lighta59dd802014-07-02 16:28:08 -0700500 exit 1;
501 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700502 fi
503fi
504
Alex Light03a112d2014-08-25 13:25:56 -0700505if [ "$have_patchoat" = "no" ]; then
506 run_args="${run_args} --no-patchoat"
507fi
508
509if [ "$have_dex2oat" = "no" ]; then
510 run_args="${run_args} --no-dex2oat"
511fi
512
Jeff Hao201803f2013-11-20 18:11:39 -0800513if [ ! "$runtime" = "jvm" ]; then
514 run_args="${run_args} --lib $lib"
515fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700516
Jeff Hao201803f2013-11-20 18:11:39 -0800517if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700518 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray6fbcc122014-07-24 00:36:48 +0100519 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800520 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700521 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700522 else
523 true # defaults to using target BOOTCLASSPATH
524 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800525elif [ "$runtime" = "art" ]; then
526 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100527 guess_host_arch_name
Richard Uhlerbb00f812017-02-16 14:21:10 +0000528 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700529 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800530 else
David Brazdil853a4c32015-09-28 16:15:50 +0100531 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800532 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Richard Uhlerbb00f812017-02-16 14:21:10 +0000533 run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800534 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700535 if [ "$relocate" = "yes" ]; then
536 run_args="${run_args} --relocate"
537 else
538 run_args="${run_args} --no-relocate"
539 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700540elif [ "$runtime" = "jvm" ]; then
541 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800542 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700543fi
544
Alex Light03a112d2014-08-25 13:25:56 -0700545if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700546 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700547 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700548 exit 1
549 fi
Alex Light03a112d2014-08-25 13:25:56 -0700550 run_args="${run_args} --no-image"
551fi
552
jeffhao5d1ac922011-09-29 17:41:15 -0700553if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700554 err_echo "--dev and --update are mutually exclusive"
555 usage="yes"
556fi
557
558if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
559 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700560 usage="yes"
561fi
562
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700563if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
564 err_echo "--bisection-search and --prebuild are mutually exclusive"
565 usage="yes"
566fi
567
568if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then
569 err_echo "--bisection-search and --no-dex2oat are mutually exclusive"
570 usage="yes"
571fi
572
573if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
574 err_echo "--bisection-search and --no-patchoat are mutually exclusive"
575 usage="yes"
576fi
577
jeffhao5d1ac922011-09-29 17:41:15 -0700578if [ "$usage" = "no" ]; then
579 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
580 test_dir=`basename "$oldwd"`
581 else
582 test_dir="$1"
583 fi
584
585 if [ '!' -d "$test_dir" ]; then
586 td2=`echo ${test_dir}-*`
587 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700588 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700589 usage="yes"
590 fi
591 test_dir="$td2"
592 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700593 # Shift to get rid of the test name argument. The rest of the arguments
594 # will get passed to the test run.
595 shift
596fi
597
Søren Gjesse620d0a52016-09-19 11:12:51 +0200598# For building with javac and dx always use Java 7. The dx compiler
599# only support byte codes from Java 7 or earlier (class file major
600# version 51 or lower).
601if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then
602 export JAVAC="${JAVAC} -source 1.7 -target 1.7"
603fi
604
jeffhao5d1ac922011-09-29 17:41:15 -0700605if [ "$usage" = "yes" ]; then
606 prog=`basename $prog`
607 (
608 echo "usage:"
609 echo " $prog --help Print this message."
610 echo " $prog [options] [test-name] Run test normally."
611 echo " $prog --dev [options] [test-name] Development mode" \
612 "(dumps to stdout)."
613 echo " $prog --update [options] [test-name] Update mode" \
614 "(replaces expected.txt)."
615 echo ' Omitting the test name or specifying "-" will use the' \
616 "current directory."
617 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000618 echo " -O Run non-debug rather than debug build (off by default)."
619 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000620 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000621 echo " --runtime-option Pass an option to the runtime."
622 echo " --debug Wait for a debugger to attach."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000623 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000624 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700625 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000626 echo " --build-only Build test files only (off by default)."
Søren Gjesse620d0a52016-09-19 11:12:51 +0200627 echo " --build-with-javac-dx Build test files with javac and dx (off by default)."
628 echo " --build-with-jack Build test files with jack and jill (on by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000629 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800630 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000631 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000632 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700633 echo " --verify-soft-fail Force soft fail verification (off by default)."
634 echo " Verification is enabled if neither --no-verify"
635 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000636 echo " --no-optimize Turn off optimization (on by default)."
637 echo " --no-precise Turn off precise GC (on by default)."
638 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700639 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000640 echo " other runtime options are ignored."
641 echo " --no-dex2oat Run as though dex2oat was failing."
642 echo " --no-patchoat Run as though patchoat was failing."
643 echo " --prebuild Run dex2oat on the files before starting test. (default)"
644 echo " --no-prebuild Do not run dex2oat on the files before starting"
645 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700646 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000647 echo " --relocate Force the use of relocating in the test, making"
648 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000649 echo " address before running."
650 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700651 echo " --image Run the test using a precompiled boot image. (default)"
652 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000653 echo " --host Use the host-mode virtual machine."
654 echo " --invoke-with Pass --invoke-with option to runtime."
655 echo " --dalvik Use Dalvik (off by default)."
656 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700657 echo " --use-java-home Use the JAVA_HOME environment variable"
658 echo " to find the java compiler and runtime"
659 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000660 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700661 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000662 echo " --64 Run the test in 64-bit mode"
663 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700664 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700665 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000666 echo " --gcstress Run with gc stress testing"
667 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700668 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
669 echo " --jvmti-redefine-stress"
670 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000671 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700672 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000673 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000674 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700675 echo " --instruction-set-features [string]"
676 echo " Set instruction-set-features for compilation."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800677 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
678 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700679 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700680 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700681 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000682 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800683 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Alex Light91de25f2015-10-28 17:00:06 -0700684 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700685 exit 1
686fi
687
688cd "$test_dir"
689test_dir=`pwd`
690
691td_info="${test_dir}/${info}"
692td_expected="${test_dir}/${expected}"
693
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700694if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700695 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700696 exit 1
697fi
698
699if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700700 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700701 exit 1
702fi
703
704# copy the test to a temp dir and run it
705
Elliott Hughes510c8782011-10-06 10:57:34 -0700706echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700707
708rm -rf "$tmp_dir"
709cp -Rp "$test_dir" "$tmp_dir"
710cd "$tmp_dir"
711
712if [ '!' -r "$build" ]; then
713 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800714else
715 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700716fi
717
718if [ '!' -r "$run" ]; then
719 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800720else
721 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700722fi
723
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700724if [ '!' -r "$check_cmd" ]; then
725 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800726else
727 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700728fi
729
jeffhao5d1ac922011-09-29 17:41:15 -0700730chmod 755 "$build"
731chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700732chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700733
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700734export TEST_NAME=`basename ${test_dir}`
735
David Brazdil4846d132015-01-15 19:07:08 +0000736# Tests named '<number>-checker-*' will also have their CFGs verified with
737# Checker when compiled with Optimizing on host.
738if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000739 if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$USE_JACK" = "true" ]; then
Nicolas Geoffrayf654ef92017-06-09 16:31:21 +0100740 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
741 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
David Brazdil80fb3942015-07-23 11:53:42 +0100742 run_checker="yes"
David Brazdil5cc343d2015-10-08 11:35:32 +0100743
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100744 if [ "$target_mode" = "no" ]; then
745 cfg_output_dir="$tmp_dir"
David Brazdil5cc343d2015-10-08 11:35:32 +0100746 checker_args="--arch=${host_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100747 else
748 cfg_output_dir="$DEX_LOCATION"
David Brazdil5cc343d2015-10-08 11:35:32 +0100749 checker_args="--arch=${target_arch_name^^}"
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100750 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100751
752 if [ "$debuggable" = "yes" ]; then
753 checker_args="$checker_args --debuggable"
754 fi
755
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100756 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
David Brazdil80fb3942015-07-23 11:53:42 +0100757 -Xcompiler-option -j1"
758 fi
David Brazdil4846d132015-01-15 19:07:08 +0000759 fi
760fi
761
Mathieu Chartier031768a2015-08-27 10:25:02 -0700762 run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700763
Richard Uhler020c0f32017-03-14 16:23:17 +0000764# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
765# ART output to approximately 128MB. This should be more than sufficient
766# for any test while still catching cases of runaway output.
767# Set a hard limit to encourage ART developers to increase the ulimit here if
768# needed to support a test case rather than resetting the limit in the run
769# script for the particular test in question.
Orion Hodsonbd328d32017-03-24 11:24:10 +0000770if ! ulimit -f 128000; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000771 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700772fi
773
jeffhao5d1ac922011-09-29 17:41:15 -0700774good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000775good_build="yes"
776good_run="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700777if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000778 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700779 build_exit="$?"
780 echo "build exit status: $build_exit" 1>&2
781 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800782 echo "${test_dir}: running..." 1>&2
783 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700784 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000785
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800786 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000787 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100788 if [ "$target_mode" = "yes" ]; then
789 adb pull $cfg_output_dir/$cfg_output &> /dev/null
790 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100791 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000792 checker_exit="$?"
793 if [ "$checker_exit" = "0" ]; then
794 good="yes"
795 fi
Alex Light91de25f2015-10-28 17:00:06 -0700796 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000797 else
798 good="yes"
799 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800800 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000801 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700802 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700803elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000804 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700805 build_exit="$?"
806 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800807 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700808 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000809 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100810 if [ "$target_mode" = "yes" ]; then
811 adb pull $cfg_output_dir/$cfg_output &> /dev/null
812 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100813 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000814 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700815 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
816 good="yes"
817 else
Alex Light91de25f2015-10-28 17:00:06 -0700818 cat "$build_output" 1>&${real_stderr} 1>&2
819 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700820 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700821elif [ "$build_only" = "yes" ]; then
822 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000823 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700824 build_exit="$?"
825 if [ "$build_exit" '!=' '0' ]; then
826 cp "$build_output" "$output"
827 echo "build exit status: $build_exit" >>"$output"
828 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
829 if [ "$?" '!=' "0" ]; then
830 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700831 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700832 fi
833 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700834 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700835 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700836 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700837else
David Brazdil4846d132015-01-15 19:07:08 +0000838 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700839 build_exit="$?"
840 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800841 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700842 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000843 run_exit="$?"
844 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700845 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000846 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000847 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100848 if [ "$target_mode" = "yes" ]; then
849 adb pull $cfg_output_dir/$cfg_output &> /dev/null
850 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100851 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000852 checker_exit="$?"
853 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700854 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000855 good_run="no"
856 else
857 good_run="yes"
858 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000859 else
860 good_run="yes"
861 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700862 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000863 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700864 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700865 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
866 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700867 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700868 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700869 max_name_length=$(getconf NAME_MAX ${tmp_dir})
870 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
871 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700872 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700873 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700874 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700875 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000876 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
877 # output == expected
878 good="yes"
879 echo "${test_dir}: succeeded!" 1>&2
880 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700881 fi
882fi
883
jeffhao5d1ac922011-09-29 17:41:15 -0700884(
Alex Lightbfac14a2014-07-30 09:41:21 -0700885 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700886 echo "${test_dir}: FAILED!"
887 echo ' '
888 echo '#################### info'
889 cat "${td_info}" | sed 's/^/# /g'
890 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700891 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700892 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700893 if [ "$strace" = "yes" ]; then
894 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700895 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700896 echo '####################'
897 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700898 echo ' '
899 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700900
Alex Light91de25f2015-10-28 17:00:06 -0700901) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700902
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700903# Attempt bisection only if the test failed.
904if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
905 # Bisecting works by skipping different optimization passes which breaks checker assertions.
906 if [ "$run_checker" == "yes" ]; then
907 echo "${test_dir}: not bisecting, checker test." 1>&2
908 else
909 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700910 echo "${test_dir}: bisecting..." 1>&2
911 cwd=`pwd`
912 maybe_device_mode=""
913 raw_cmd=""
914 if [ "$target_mode" = "yes" ]; then
915 # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option
916 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
917 # to exec in order to preserve pid when calling dalvikvm. This is required
918 # for bisection search to correctly retrieve logs from device.
919 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
920 adb shell chmod u+x "$DEX_LOCATION/cmdline.sh"
921 maybe_device_mode="--device"
922 raw_cmd="$DEX_LOCATION/cmdline.sh"
923 else
924 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
925 fi
926 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
927 $maybe_device_mode \
928 --raw-cmd="$raw_cmd" \
929 --check-script="$cwd/check" \
930 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -0700931 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700932 --timeout=300
933 fi
934fi
935
Alex Lightbfac14a2014-07-30 09:41:21 -0700936# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -0700937if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -0700938 cd "$oldwd"
939 rm -rf "$tmp_dir"
940 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
941 adb shell rm -rf $DEX_LOCATION
942 fi
943 if [ "$good" = "yes" ]; then
944 exit 0
945 fi
946fi
947
948
949(
950 if [ "$always_clean" = "yes" ]; then
951 echo "${TEST_NAME} files deleted from host "
952 if [ "$target_mode" == "yes" ]; then
953 echo "and from target"
954 fi
955 else
956 echo "${TEST_NAME} files left in ${tmp_dir} on host"
957 if [ "$target_mode" == "yes" ]; then
958 echo "and in ${DEX_LOCATION} on target"
959 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -0700960 fi
961
Alex Light91de25f2015-10-28 17:00:06 -0700962) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700963
Alex Light6a870fa2016-05-31 16:36:19 -0700964if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
965 exit 0
966else
967 exit 1
968fi